# ---------------------------
# Testing workflow
# ---------------------------

# test template used in other jobs
# see python.yml for example

.zookeeper_service: &zookeeper_service
  name: zookeeper:3.6
  alias: zookeeper

.kafka_service: &kafka_service
  name: bitnami/kafka:3.1
  alias: kafka

.test:
  extends:
    - .python:pytest
  stage: Testing
  needs:
    - tarball
  variables:
    # configure pytest
    PYTEST_OPTIONS: "-ra -v -s -c ${CI_PROJECT_DIR}/pyproject.toml --pyargs igwn_lldd_common.tests"
    # use python3
    PYTHON: "python3"
    # Allow Zookeeper to accept connections from unauthenticated users
    ALLOW_ANONYMOUS_LOGIN: "yes"
    # The id for the kafka broker
    KAFKA_BROKER_ID: 1
    # The internal Kafka lister
    KAFKA_CFG_LISTENERS: "PLAINTEXT://:9092"
    # The external Kafka lister
    KAFKA_CFG_ADVERTISED_LISTENERS: "PLAINTEXT://kafka:9092"
    # Where to connect to zookeeper
    KAFKA_CFG_ZOOKEEPER_CONNECT: "zookeeper:2181"
    # Allow authentication through plaintext
    ALLOW_PLAINTEXT_LISTENER: "yes"
    # Allow zookeeper and kafka to communicate in a CI job
    FF_NETWORK_PER_BUILD: 1
    # The place to boostrap the Kakfa Broker
    KAFKA_BROKER: "kafka:9092"
  services:
    - *zookeeper_service
    - *kafka_service
  before_script:
    # resolve wildcard in wheel so we specify the test extra
    - TARBALL=$(echo igwn-lldd-common-*.tar.*)
    - INSTALL_TARGET="${TARBALL}[test]"
    # configure from template
    - !reference [".python:pytest", before_script]
  script:
    # show package metadata
    - python3 -m pip show igwn-lldd-common
    # run pytest
    - !reference [".python:pytest", script]
  # upload coverage database to be aggregated later
  artifacts:
    paths:
      - .coverage*
  # disable coverage total parsing, this is reported by
  # the coverage job
  coverage: null

# -- coverage ---------------
#
# This job combinces the individual
# coverage reports from each job
# to make a proper coverage result
#

coverage:
  stage: Code quality
  extends:
    # https://computing.docs.ligo.org/gitlab-ci-templates/python/#.python:coverage-combine
    - .python:coverage-combine
